window.Gleam.initSearch([{"doc":"conversation","title":"conversation","content":"# conversation\n\n[![Package Version](https://img.shields.io/hexpm/v/conversation)](https://hex.pm/packages/conversation)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/conversation/)\n\nGleam bindings for the standard JavaScript [Request](https://developer.mozilla.org/en-US/docs/Web/API/Request) and [Response](https://developer.mozilla.org/en-US/docs/Web/API/Response) APIs.\n\n## Installation\n\nThis package can be added to your Gleam project:\n\n```sh\ngleam add conversation\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/conversation&gt;.\n\n## Example Usage\n\nAn example wrapper for `Deno.serve` that uses `conversation` can be found in [./test](./test/). The example can be run with the command `gleam test`.","url":"index.html"},{"doc":"conversation","title":"FormData","content":"pub type FormData {\n  FormData(\n    values: List(#(String, String)),\n    files: List(#(String, UploadedFile)),\n  )\n}\n Data parsed from form sent in a request&#39;s body.\nFormData(\n  values: List(#(String, String)),\n  files: List(#(String, UploadedFile)),\n)\n\nvalues\n&lt;p&gt;String values of the form’s fields, sorted alphabetically.&lt;/p&gt;\n\nfiles\n&lt;p&gt;Uploaded files, sorted alphabetically by file name.&lt;/p&gt;\n\nSynonyms:\nconversation.FormData\nconversation FormData","url":"conversation.html#FormData"},{"doc":"conversation","title":"JsReadableStream","content":"pub type JsReadableStream\n A JavaScript [`ReadableStream`](https://developer.mozilla.org/en-US/docs/Web/API/ReadableStream).\n\nSynonyms:\nconversation.JsReadableStream\nconversation JsReadableStream","url":"conversation.html#JsReadableStream"},{"doc":"conversation","title":"JsRequest","content":"pub type JsRequest\n A standard JavaScript [`Request`](https://developer.mozilla.org/en-US/docs/Web/API/Request).\n\nSynonyms:\nconversation.JsRequest\nconversation JsRequest","url":"conversation.html#JsRequest"},{"doc":"conversation","title":"JsResponse","content":"pub type JsResponse\n A standard JavaScript [`Response`](https://developer.mozilla.org/en-US/docs/Web/API/Response).\n\nSynonyms:\nconversation.JsResponse\nconversation JsResponse","url":"conversation.html#JsResponse"},{"doc":"conversation","title":"ReadError","content":"pub type ReadError {\n  AlreadyRead\n  ParseError(message: String)\n  ReadError(message: String)\n}\n Error type representing possible errors produced by body reading functions.\nAlreadyRead\n Request body has already been read.\n\nParseError(message: String)\n Failed to parse JSON or form body.\n\nReadError(message: String)\n Failed to read request body.\n\nSynonyms:\nconversation.ReadError\nconversation ReadError","url":"conversation.html#ReadError"},{"doc":"conversation","title":"RequestBody","content":"pub type RequestBody\n The body of an incoming request. It must be read with functions like\n [`read_text`](#read_text), and can only be read once.\n\nSynonyms:\nconversation.RequestBody\nconversation RequestBody","url":"conversation.html#RequestBody"},{"doc":"conversation","title":"ResponseBody","content":"pub type ResponseBody {\n  Text(String)\n  Bits(BitArray)\n  Stream(JsReadableStream)\n}\n Body type for an outgoing response.\n\n \n import gleam/http/response\n import conversation.{Text}\n\n response.new(200)\n |&gt; response.set_body(Text(&quot;Hello, world!&quot;))\n \nText(String)\n A text body.\n\nBits(BitArray)\n A BitArray body.\n\nStream(JsReadableStream)\n A [`JsReadableStream`](#JsReadableStream) body. This is useful for sending\n files without reading them into memory. (For example: using the\n `Deno.openSync(path).readable` API.)\n\nSynonyms:\nconversation.ResponseBody\nconversation ResponseBody","url":"conversation.html#ResponseBody"},{"doc":"conversation","title":"UploadedFile","content":"pub type UploadedFile {\n  UploadedFile(file_name: String)\n}\n File uploaded from the client. Conversation does not currently support reading\n the file&#39;s contents.\nUploadedFile(file_name: String)\n\nfile_name\n&lt;p&gt;The name that was given to the file in the form.\nThis is user input and should not be trusted.&lt;/p&gt;\n\nSynonyms:\nconversation.UploadedFile\nconversation UploadedFile","url":"conversation.html#UploadedFile"},{"doc":"conversation","title":"read_bits","content":"pub fn read_bits(\n  body: RequestBody,\n) -&gt; Promise(Result(BitArray, ReadError))\n Read a request body as a BitArray.\nSynonyms:\nconversation.read_bits\nconversation read_bits","url":"conversation.html#read_bits"},{"doc":"conversation","title":"read_form","content":"pub fn read_form(\n  body: RequestBody,\n) -&gt; Promise(Result(FormData, ReadError))\n Read a request body as [`FormData`](#FormData). If the formdata cannot be\n parsed, a [`ParseError`](#ReadError) is returned.\nSynonyms:\nconversation.read_form\nconversation read_form","url":"conversation.html#read_form"},{"doc":"conversation","title":"read_json","content":"pub fn read_json(\n  body: RequestBody,\n) -&gt; Promise(Result(Dynamic, ReadError))\n Read a request body as JSON, returning a\n [`Dynamic`](https://hexdocs.pm/gleam_stdlib/gleam/dynamic.html#Dynamic) value\n which can then be decoded with [`gleam_json`](https://hexdocs.pm/gleam_json/).\n If the JSON cannot be parsed, a [`ParseError`](#ReadError) is returned.\nSynonyms:\nconversation.read_json\nconversation read_json","url":"conversation.html#read_json"},{"doc":"conversation","title":"read_text","content":"pub fn read_text(\n  body: RequestBody,\n) -&gt; Promise(Result(String, ReadError))\n Read a request body as text.\nSynonyms:\nconversation.read_text\nconversation read_text","url":"conversation.html#read_text"},{"doc":"conversation","title":"translate_request","content":"pub fn translate_request(req: JsRequest) -&gt; Request(RequestBody)\n Translates a [`JsRequest`](#JsRequest) into a Gleam\n [`Request`](https://hexdocs.pm/gleam_http/gleam/http/request.html#Request).\nSynonyms:\nconversation.translate_request\nconversation translate_request","url":"conversation.html#translate_request"},{"doc":"conversation","title":"translate_response","content":"pub fn translate_response(\n  res: Response(ResponseBody),\n) -&gt; JsResponse\n Translates a Gleam [`Response`](https://hexdocs.pm/gleam_http/gleam/http/response.html#Response)\n into a [`JsResponse`](#JsResponse).\nSynonyms:\nconversation.translate_response\nconversation translate_response","url":"conversation.html#translate_response"},{"doc":"conversation","title":"conversation","content":"","url":"conversation.html"}]);